package manager;


/**
 * This class extends the generic board game class {@link Game} to support a checkers game.
 * 
 * @author Luciano Antonio Digiampietri
 * @version 0.5 beta - 03/15/2006
 * 
 * @see   Game
 */

public class CheckersGame extends Game {
	private int PLAYER1 = -1;
	private int PLAYER2 = -1;
	boolean EAT_MOVE = false;
	private Piece EAT_PIECE = new NullPiece();

	public CheckersGame(String name){
		super(name);
		GAME_TYPE = "checkers";
		MAX_PLAYERS = 2;
		MIN_PLAYERS = 2;
	}
	
	public CheckersGame(String name, int player1) {
		super(name, player1);
		GAME_TYPE = "checkers";
		MAX_PLAYERS = 2;
		MIN_PLAYERS = 2;
		PLAYER1 = player1;
	}

	public void startGame(){
		System.out.println("# of Players:" + PLAYERS.size());
		if (PLAYERS.size() == 2){
			PLAYER1 = ((Integer)PLAYERS.get(0)).intValue();
			PLAYER2 = ((Integer)PLAYERS.get(1)).intValue();
			ACTUAL_PLAYER = PLAYER1;
			WAITING_PLAYERS=false;
			GAME_ENDED = false;
			insertPieces();
		}else{
			System.err.println("Wrong number of players:" + PLAYERS.size());
		}
	}
	

	
	public boolean endTurn(int Player){
		if (EAT_MOVE && Player == ACTUAL_PLAYER){
			EAT_MOVE = false;
			if (Player == PLAYER1){
				ACTUAL_PLAYER = PLAYER2;
			}else{
				ACTUAL_PLAYER = PLAYER1;
			}		
		CONT_ID++;
		return true;
		}
		return false;
	}
	
	
		
	public boolean isPossibleToKeepEating (int x, int y, int Player){
		if (canEatSomething(x,y,Player)){
			return true;
		}
		return false;
	}

	public boolean canEatSomething (int x, int y, int Player){
		if (canMove(x,y,x+2,y+2,Player)) return true;
		if (canMove(x,y,x+2,y-2,Player)) return true;
		if (canMove(x,y,x-2,y+2,Player)) return true;
		if (canMove(x,y,x-2,y-2,Player)) return true;
		return false;
	}

	
	public boolean move(int x1, int y1, int x2, int y2, int Player){
		if (canMove(x1, y1, x2, y2, Player)){
			BOARD.movePiece(x1,y1,x2,y2);
			if ((Player == PLAYER1) && (x2==7)){
				((CheckersPiece)BOARD.getPiece(x2,y2)).TYPE = CheckersPiece.CHECKER;
			}else if((Player == PLAYER2) && (x2==0)){
				((CheckersPiece)BOARD.getPiece(x2,y2)).TYPE = CheckersPiece.CHECKER;
			}
			
			if (Math.abs(x2-x1) == 2 && Math.abs(y2-y1)==2){
				int x_adversary = x1+(x2-x1)/2;
				int y_adversary = y1+(y2-y1)/2;
				eat(x_adversary,y_adversary);
				 if (isPossibleToKeepEating(x2,y2,Player)){
					 EAT_MOVE=true;
					 EAT_PIECE = BOARD.getPiece(x2,y2);
					 CONT_ID++;
					 return true;
				 }
			}
			EAT_MOVE=false;
			if (Player == PLAYER1){
				ACTUAL_PLAYER = PLAYER2;
			 }else{
				ACTUAL_PLAYER = PLAYER1;
			  }
			  CONT_ID++;
			  return true;
		}
		return false;
	}

	public boolean canMove(int x1, int y1, int x2, int y2, int Player){
		//System.out.println("Trying to move checkers.");
		if (GAME_ENDED || WAITING_PLAYERS){
			return false;
		}
		if (Player != ACTUAL_PLAYER){
			return false;
		}
		
		if (!BOARD.validCell(x1,y1) || !BOARD.validCell(x2,y2)){
			return false;
		}
		
		if (BOARD.getPiece(x1,y1).getClass() == NullPiece.class){
			return false;
		}
		if (BOARD.getPiece(x2,y2).getClass() != NullPiece.class){
			return false;
		}

		if (BOARD.getPiece(x1,y1).getClass() == NullPiece.class){
			return false;
		}
				
		CheckersPiece P1 = (CheckersPiece)BOARD.getPiece(x1,y1); 
		if (P1.getPlayer() != Player){
			System.out.println("player:" + P1.getPlayer());
			return false;
		}
		
		
		/////////////// VERIFYING NORMAL MOVEMENT (NO PIECE EATEN)
		if ((Math.abs(x2-x1) == 1 && Math.abs(y2-y1)==1) && !EAT_MOVE){
			if (P1.TYPE == CheckersPiece.CHECKER){
				return true;
			}else if (P1.TYPE == CheckersPiece.SIMPLE){
				if (Player == PLAYER1){
					if (x2>x1){
						return true;
					}
				}else if (Player == PLAYER2){
					if (x2<x1){
						return true;
					}			
				}else{
					System.out.println("Invalid player name: " + Player);
				}
			}else{
				System.out.println("Invalid piece type: " + P1.TYPE);
			}
		}else{
			///////////////// VERIFICAR MOVIMENTO "NAO NORMAL"; COMENDO PEAS
			//System.out.println("can move2");
			if ((Math.abs(x2-x1) == 2 && Math.abs(y2-y1)==2)&&(!EAT_MOVE || EAT_PIECE == BOARD.getPiece(x1,y1))){
				int x_adversary = x1+(x2-x1)/2;
				int y_adversary = y1+(y2-y1)/2;
				if (isAdversary((Piece)BOARD.getPiece(x_adversary,y_adversary),Player)){
					if (P1.TYPE == CheckersPiece.CHECKER){
						if (canEat(x_adversary,y_adversary)){
							return true;
						}
					}else if (P1.TYPE == CheckersPiece.SIMPLE){
						if (Player == PLAYER1){
							if (x2>x1){
								if (canEat(x_adversary,y_adversary)){
									return true;
								}
							}
						}else if (Player == PLAYER2){
							if (x2<x1){
								if (canEat(x_adversary,y_adversary)){
									return true;
								}
							}			
						}else{
							System.out.println("Invalid player name: " + Player);
						}
					}else{
						System.out.println("Invalid piece type: " + P1.TYPE);
					}
				}
			}
		}
		return false;
	}

	public boolean isAdversary(Piece P1, int Player){
		int temp_player = P1.getPlayer();
		if ((temp_player == PLAYER1) || (temp_player == PLAYER2)){
			if (((Player == PLAYER1) || (Player == PLAYER2)) && temp_player != Player){
				return true;
			}
		}
		return false;
	}

	public boolean eat(int x, int y){
		if (BOARD.getPiece(x,y).getClass() == CheckersPiece.class){
			if (BOARD.removePiece(x,y)){
				if (gameEnded()){
					System.out.println("End game. Winner: " + WINNER);
				}
				return true;
			}
		}
		return false;
	}

	public boolean canEat(int x, int y){
		if (BOARD.getPiece(x,y).getClass() == CheckersPiece.class){
			return true;
		}
		return false;
	}

	
	public boolean canAdd(int x, int y, Piece P){
		return false;
	}
	
	public boolean add(int x, int y, String Player){
		return false;
	}
	
	public void initializeBoard(){
		BOARD = new Board(8,8);
	}

	public void insertPieces(){
		for (int cont=0;cont<4;cont++){
			BOARD.addPiece(0, cont*2,new CheckersPiece("x",PLAYER1,CheckersPiece.SIMPLE));
			BOARD.addPiece(1, 1+cont*2,new CheckersPiece("x",PLAYER1,CheckersPiece.SIMPLE));
			BOARD.addPiece(2, cont*2,new CheckersPiece("x",PLAYER1,CheckersPiece.SIMPLE));
			
			BOARD.addPiece(5, 1+cont*2,new CheckersPiece("o",PLAYER2,CheckersPiece.SIMPLE));
			BOARD.addPiece(6, cont*2,new CheckersPiece("o",PLAYER2,CheckersPiece.SIMPLE));
			BOARD.addPiece(7, 1+cont*2,new CheckersPiece("o",PLAYER2,CheckersPiece.SIMPLE));
		}
	}
	
	public boolean gameEnded(){
		if (GAME_ENDED){
			return true;
		}
		if (player1Won()){
			WINNER = PLAYER1;
			GAME_ENDED = true;
			return true;
		}else if (player2Won()){
			WINNER = PLAYER2;
			GAME_ENDED = true;
			return true;
		}
		return false;
	}
	
	public boolean player1Won(){
		if (WINNER != -1 && WINNER == PLAYER1){
			return true;
		}else if (won(PLAYER1)){
			WINNER = PLAYER1;
			return true;
		}
		return false;
	}
	public boolean player2Won(){
		if (WINNER != -1 && WINNER == PLAYER2){
			return true;
		}else if (won(PLAYER2)){
			WINNER = PLAYER2;
			return true;
		}
		return false;
	}	
	
	 
	public boolean won(int Player){
		int cont_X = BOARD.contPieces(PLAYER1);
		int cont_O = BOARD.contPieces(PLAYER2);
		if (PLAYER1 == Player && cont_O == 0 && cont_X > 0){
			return true;
		}else if (PLAYER2 == Player && cont_X == 0 && cont_O > 0){
			return true;
		}
		return false;
	}	
}