package manager;

/**
 * This class implements the two kind of checkers piece (simple and checker).
 * It extends a generic {@link Piece} to support the piece types
 * of checkers games (simple and checker).
 * <p>
 * Checkers pieces are used in the {@link CheckersGame}
 *  
 * @author Luciano Antonio Digiampietri
 * @version 0.5 beta - 03/15/2006
 * @see CheckersGame
 * @see Piece
 */
public class CheckersPiece extends Piece{
	final static String SIMPLE = "simple";
	final static String CHECKER = "checker";
	protected String TYPE = SIMPLE;
	
	public CheckersPiece(String id, int player) {
		super(id, player);
	}

	public CheckersPiece(String id, int player, String type) {
		super(id, player);
		this.TYPE = type;
	}
	
	//// VALID TYPES: simple / checker
	//// VALID IDS  : x | X  / o | O 
	

	public String getString(){
		if (TYPE == SIMPLE){
			return ID.toLowerCase();
		}else if (TYPE == CHECKER){
			return ID.toUpperCase();
		}
		return "ERROR - invalid type: "+TYPE;
	}
	
}
