package manager;

/**
 * This class implements any chess piece.
 * It extends a generic {@link Piece} to support the
 * chess' pieces (king, queen, rook, bishop, knight, pawn).
 * <p>
 * Chess pieces are used in the {@link ChessGame}
 *  
 * @author Luciano Antonio Digiampietri
 * @version 0.5 beta - 03/15/2006
 * @see DeflexionGame
 * @see Piece
 */
public class ChessPiece extends Piece{
	final static String KING   = "king";
	final static String QUEEN  = "queen";
	final static String ROOK   = "rook";
	final static String BISHOP = "bishop";
	final static String KNIGHT = "knight";
	final static String PAWN   = "pawn";
	
	private String type = PAWN;
	public ChessPiece(String id, int player) {
		super(id, player);
	}

	public ChessPiece(String id, int player, String type) {
		super(id, player);
		this.type = type;
	}

	public String get_type(){
		return type;
	}
	

	public String getString(){
		if (type.equalsIgnoreCase(KING)){
			return ID + "Kin" +ID;
		}else if (type.equalsIgnoreCase(QUEEN)){
			return ID + "Que" + ID;
		}else if (type.equalsIgnoreCase(ROOK)){
			return ID + "Roo" + ID;
		}else if (type.equalsIgnoreCase(BISHOP)){
			return ID + "Bis" + ID;
		}else if (type.equalsIgnoreCase(KNIGHT)){
			return ID + "Kni" + ID;
		}else if (type.equalsIgnoreCase(PAWN)){
			return ID + "Paw" + ID;
		}
		
		System.err.println("Invalid chess type: " + type);
		return "ERROR - invalid type: "+type;
	}
	
}
