
package manager;


/**
 * This class extends the generic board game class {@link Game} to support a deflexion game.
 * 
 * @author Luciano Antonio Digiampietri
 * @version 0.5 beta - 03/15/2006
 * 
 * @see   Game
 */
public class DeflexionGame extends Game {
	private int PLAYER1 = -1; // GOLD
	private int PLAYER2 = -1; // SILVER
	boolean CONFIRM_MOVE = false;
	private Action LAST_ACTION = new Action(Action.NULL_ACTION);
//	private piece EAT_PIECE = new null_piece();
	public final static String CLOCKWISE = "CLOCKWISE";
	public final static String ANTICLOCKWISE = "ANTICLOCKWISE";
	
	public DeflexionGame(String name){
		super(name);
		GAME_TYPE = "deflexion";
		MAX_PLAYERS = 2;
		MIN_PLAYERS = 2;
	}
	
	public DeflexionGame(String name, int player1) {
		super(name, player1);
		GAME_TYPE = "deflexion";
		MAX_PLAYERS = 2;
		MIN_PLAYERS = 2;
		PLAYER1 = player1;
	}

	public void startGame(){
		if (PLAYERS.size() == 2){
			PLAYER1 = ((Integer)PLAYERS.get(0)).intValue();
			PLAYER2 = ((Integer)PLAYERS.get(1)).intValue();
			ACTUAL_PLAYER = PLAYER1;
			System.out.println("Deflexion, players: " + PLAYER1 + " ; " + PLAYER2);
			WAITING_PLAYERS=false;
			GAME_ENDED = false;
			CONFIRM_MOVE = false;
			insertPieces();
		}else{
			System.err.println("Wrong number of players:" + PLAYERS.size());
		}
	}
	

	public boolean endTurn(int Player){
		System.out.println("Deflexion end turn1");
		if (CONFIRM_MOVE && Player == ACTUAL_PLAYER){
			CONFIRM_MOVE = false;
			disparLaser(Player);
			System.out.println("Deflexion end turn2");
			if (Player == PLAYER1){
				ACTUAL_PLAYER = PLAYER2;
			}else{
				ACTUAL_PLAYER = PLAYER1;
			}		
		CONT_ID++;
		return true;
		}
		return false;
	}
		
		
/*	public boolean is_possible_to_keep_move (int x, int y, String Player){
		if (can_eat_something(x,y,Player)){
			return true;
		}
		return false;
	}
	*/

	/*
	public boolean can_eat_something (int x, int y, String Player){
		if (can_move(x,y,x+2,y+2,Player)) return true;
		if (can_move(x,y,x+2,y-2,Player)) return true;
		if (can_move(x,y,x-2,y+2,Player)) return true;
		if (can_move(x,y,x-2,y-2,Player)) return true;
		return false;
	}*/

	
	public boolean move(int x1, int y1, int x2, int y2, int Player){
		//#!!!
		if (canMove(x1, y1, x2, y2, Player)){
			BOARD.replacePiece(x1,y1,x2,y2);
			CONFIRM_MOVE=true;
			/*if (Player == Player1){
				Actual_player = Player2;
			 }else{
				Actual_player = Player1;
			  }
			  */
			  CONT_ID++;
			  endTurn(Player);
			  return true;
		}
		return false;
	}

	public boolean canMove(int x1, int y1, int x2, int y2, int Player){
		System.out.println("Deflexion can move: " + x1 + " " + x2 + " " + y1 + " " + y2 + " " + Player +" " + PLAYER1 + " " + PLAYER2 + " " + GAME_ENDED);
		if (GAME_ENDED){
			return false;
		}
		
		if (CONFIRM_MOVE){
			return false;
		}

		if ((Math.abs(x2-x1) > 1 || Math.abs(y2-y1)>1)){
			return false;
		}
		
		if ((Math.abs(x2-x1) == 0 && Math.abs(y2-y1)==0)){
			return false;
		}
		
		//System.out.println("Moving deflexion1");
		
		if (Player != ACTUAL_PLAYER){
			return false;
		}
		
		if (!BOARD.validCell(x1,y1) || !BOARD.validCell(x2,y2)){
			return false;
		}
		
		if (BOARD.getPiece(x1,y1).getClass() == NullPiece.class){
			return false;
		}
		
		//System.out.println("Moving deflexion2");
		
		if (BOARD.getPiece(x2,y2).getClass() != NullPiece.class){
			System.out.println("Moving deflexion2.1");
			if (!((DeflexionPiece)BOARD.getPiece(x1,y1)).get_type().equalsIgnoreCase(DeflexionPiece.DJED)){
				System.out.println("Moving deflexion2.2");
				return false;
			}else{
				System.out.println("Moving deflexion2.3");
				String temp_type = ((DeflexionPiece)BOARD.getPiece(x2,y2)).get_type();
				if ((temp_type.equals(DeflexionPiece.DJED)) || (temp_type.equalsIgnoreCase(DeflexionPiece.PHAROAH))){
					System.out.println("Moving deflexion4");
					return false;
				}
			}
		}

		//System.out.println("Moving deflexion3");
		
		if (BOARD.getPiece(x1,y1).getClass() == NullPiece.class){
			return false;
		}
		
		//System.out.println("Moving deflexion3.5");
		
		DeflexionPiece P1 = (DeflexionPiece)BOARD.getPiece(x1,y1); 
		System.out.println(Player + " " + P1.getPlayer());
		if (P1.getPlayer() != Player){
			return false;
		}
		
		//System.out.println("Moving deflexion4");
		
		// Verificar as colunas laterais (0=gold; 9=silver)
		if ((y2==0) && (P1.getPlayer() == PLAYER2)){ 
			return false;
		}

		//System.out.println("Moving deflexion5");
		
		if ((y2==9) && (P1.getPlayer() == PLAYER1)){ 
			return false;
		}
				
		return true;
	}

	public boolean canRotate(int x, int y, int Player){
		if (BOARD.validCell(x,y)){
			if (BOARD.getPiece(x,y).getClass() == DeflexionPiece.class){
				if (((DeflexionPiece)BOARD.getPiece(x,y)).get_type().equalsIgnoreCase(DeflexionPiece.DJED) || ((DeflexionPiece)BOARD.getPiece(x,y)).get_type().equalsIgnoreCase(DeflexionPiece.PYRAMID)){
					return true;
				}
			}
		}
		return false;
	}
	
	public boolean rotate(int x, int y, String direction, int Player){
		if (ACTUAL_PLAYER == Player){
			if (canRotate(x,y,Player)){
				DeflexionPiece P1 = ((DeflexionPiece)BOARD.getPiece(x,y));
				String ori = P1.get_orientation();
				if (direction.equalsIgnoreCase(CLOCKWISE)){
					if (ori.equalsIgnoreCase("NE")){
						P1.update_orientation("SE");
					}else if (ori.equalsIgnoreCase("SE")){
						P1.update_orientation("SW");
					}else if (ori.equalsIgnoreCase("SW")){
						P1.update_orientation("NW");
					}else if (ori.equalsIgnoreCase("NW")){
						P1.update_orientation("NE");
					}else{
						System.out.println("Invalid orientation: " + ori);
					}
				}else if (direction.equalsIgnoreCase(ANTICLOCKWISE)){
					if (ori.equalsIgnoreCase("NE")){
						P1.update_orientation("NW");
					}else if (ori.equalsIgnoreCase("SE")){
						P1.update_orientation("NE");
					}else if (ori.equalsIgnoreCase("SW")){
						P1.update_orientation("SE");
					}else if (ori.equalsIgnoreCase("NW")){
						P1.update_orientation("SW");
					}else{
						System.out.println("Invalid orientation: " + ori);
					}
				}else{
					System.out.println("Invalid type of rotation.");
					return false;
				}
				System.out.println("Deflexion rotation OK");
				BOARD.replacePiece(x,y,P1);
				CONFIRM_MOVE = true;
				endTurn(Player);
				return true;
			}
		}
		return false;
	}

	
	/*
	public boolean is_adversary(piece P1, String Player){
		String temp_player = P1.get_player();
		if ((temp_player == Player1) || (temp_player == Player2)){
			if (((Player == Player1) || (Player == Player2)) && temp_player != Player){
				return true;
			}
		}
		return false;
	}*/

	
	public boolean burn(int x, int y){
		System.out.println("Burning: " + x + "," + y);
		System.out.println(BOARD.getPiece(x,y).getClass().toString());
		if (BOARD.getPiece(x,y).getClass() == DeflexionPiece.class){
			String deleted_type =((DeflexionPiece)BOARD.getPiece(x,y)).get_type();
			int deleted_player =((DeflexionPiece)BOARD.getPiece(x,y)).getPlayer();
			if (BOARD.removePiece(x,y)){
				if (deleted_type.equalsIgnoreCase(DeflexionPiece.PHAROAH)){
					GAME_ENDED = true;
					if (deleted_player == PLAYER1){
						WINNER = PLAYER2;
					}else if (deleted_player == PLAYER2){
						WINNER = PLAYER1; 
					}else{
						System.out.println("Invalid player - burn end game");
					}
				
					System.out.println("End game. Winner: " + WINNER);
				}
				CONT_ID++;
				return true;
			}
		}
		return false;
	}

	public boolean disparLaser(int Player){
		int laser_x = 0;
		int laser_y = 0;
		String orientation = "S";
		if (Player == PLAYER2){
			laser_x = 7;
			laser_y = 9;
			orientation = "N";			
		}else if (Player == PLAYER1){
			laser_x = 0;
			laser_y = 0;
			orientation = "S";			
		}else{
			System.out.println("Invalid player: '"+Player+"'");
			return false;
		}
		System.out.println("Disparing laser:");
		LAST_MESSAGE = "<LASER>";
		auxDisparLaser(laser_x,laser_y,orientation);
		LAST_MESSAGE += "</LASER>";
		CONT_ID++;
		return true;
	}

	public void auxDisparLaser(int x, int y, String laser_orientation){
		if (BOARD.validCell(x,y)){
			System.out.print(x + "," +  y + " " + laser_orientation + " ");
			LAST_MESSAGE += x + "," +  y + " " + laser_orientation + ";";
			Piece P1 = BOARD.getPiece(x,y);
			if (P1.getClass() == NullPiece.class){
				if (laser_orientation.equalsIgnoreCase("N")){
					auxDisparLaser(x-1,y, laser_orientation);
				}else if (laser_orientation.equalsIgnoreCase("S")){
					auxDisparLaser(x+1,y, laser_orientation);
				}else if (laser_orientation.equalsIgnoreCase("E")){
					auxDisparLaser(x,y+1, laser_orientation);
				}else if (laser_orientation.equalsIgnoreCase("W")){
					auxDisparLaser(x,y-1, laser_orientation);
				}else  {
					System.out.println("ERROR invalid laser orientation - aux_dispar_laser");
				}
			}else if (P1.getClass() == DeflexionPiece.class){
				String type = ((DeflexionPiece)P1).get_type();
				if ((type.equalsIgnoreCase(DeflexionPiece.PHAROAH)) || (type.equalsIgnoreCase(DeflexionPiece.OBELISK))){
					burn(x,y);
					LAST_MESSAGE += P1.getString();
				}else{
					String ori = ((DeflexionPiece)P1).get_orientation();
					//if (laser_orientation.equalsIgnoreCase("")){
					String tag1 = "";
					String tag2 = "";
					if (laser_orientation.equalsIgnoreCase("N")){
						tag1 = "NE";
						tag2 = "NW";
					}else if (laser_orientation.equalsIgnoreCase("S")){
						tag1 = "SE";
						tag2 = "SW";
					}else if (laser_orientation.equalsIgnoreCase("E")){
						tag1 = "NE";
						tag2 = "SE";
					}else if (laser_orientation.equalsIgnoreCase("W")){
						tag1 = "SW";
						tag2 = "NW";
					}
						
					//if (ori.contains(laser_orientation)){
					if (ori.equalsIgnoreCase(tag1) || ori.equalsIgnoreCase(tag2)){
							burn(x,y);
							LAST_MESSAGE += P1.getString();
					}else{
						if ((laser_orientation.equalsIgnoreCase("N")) || (laser_orientation.equalsIgnoreCase("S"))){
							
							//if (ori.contains("E")){
							if (ori.equalsIgnoreCase("NE") || ori.equalsIgnoreCase("SE")){
								auxDisparLaser(x,y+1,"E");
							//}else if (ori.contains("W")){
							}else if (ori.equalsIgnoreCase("NW") || ori.equalsIgnoreCase("SW")){
								auxDisparLaser(x,y-1,"W");
							}else{
								System.out.println("ERROR invalid deflexion: " + laser_orientation + " - " + ori +"- aux_dispar_laser");
							}
						}else if ((laser_orientation.equalsIgnoreCase("E")) || (laser_orientation.equalsIgnoreCase("W"))){
							//if (ori.contains("N")){
							if (ori.equalsIgnoreCase("NE") || ori.equalsIgnoreCase("NW")){
								auxDisparLaser(x-1,y,"N");
							//}else if (ori.contains("S")){
							}else if (ori.equalsIgnoreCase("SE") || ori.equalsIgnoreCase("SW")){
								auxDisparLaser(x+1,y,"S");
							}else{
								System.out.println("ERROR invalid deflexion2: " + laser_orientation + " - " + ori +"- aux_dispar_laser");
							}							
						}else{
							System.out.println("ERROR invalid deflexion3: " + laser_orientation + " - " + ori +"- aux_dispar_laser");
						}
					}
				}
				
			}else{
				System.out.println("ERROR invalid class piece type - aux_dispar_laser");
			}
		}else{
			System.out.println("No piece burned.");
		}
	}
	
	public boolean canAdd(int x, int y, Piece P){
		return false;
	}
	
	public boolean add(int x, int y, String Player){
		return false;
	}
	
	public void initializeBoard(){
		BOARD = new Board(8,10);
	}

	public void insertPieces(){
		for (int cont=0;cont<4;cont++){
			
			BOARD.addPiece(3, 0,new DeflexionPiece("X",PLAYER1,DeflexionPiece.PYRAMID,"NE"));
			BOARD.addPiece(4, 0,new DeflexionPiece("X",PLAYER1,DeflexionPiece.PYRAMID,"SE"));
			BOARD.addPiece(1, 2,new DeflexionPiece("X",PLAYER1,DeflexionPiece.PYRAMID,"SW"));
			BOARD.addPiece(0, 7,new DeflexionPiece("X",PLAYER1,DeflexionPiece.PYRAMID,"SE"));
			BOARD.addPiece(3, 7,new DeflexionPiece("X",PLAYER1,DeflexionPiece.PYRAMID,"SE"));
			BOARD.addPiece(4, 7,new DeflexionPiece("X",PLAYER1,DeflexionPiece.PYRAMID,"NE"));
			BOARD.addPiece(5, 6,new DeflexionPiece("X",PLAYER1,DeflexionPiece.PYRAMID,"SE"));

			BOARD.addPiece(3, 4,new DeflexionPiece("X",PLAYER1,DeflexionPiece.DJED,"SW"));
			BOARD.addPiece(3, 5,new DeflexionPiece("X",PLAYER1,DeflexionPiece.DJED,"SE"));
			
			BOARD.addPiece(0, 4,new DeflexionPiece("X",PLAYER1,DeflexionPiece.OBELISK));
			BOARD.addPiece(0, 6,new DeflexionPiece("X",PLAYER1,DeflexionPiece.OBELISK));
			
			BOARD.addPiece(0, 5,new DeflexionPiece("X",PLAYER1,DeflexionPiece.PHAROAH));

						
			BOARD.addPiece(3, 2,new DeflexionPiece("O",PLAYER2,DeflexionPiece.PYRAMID,"SW"));
			BOARD.addPiece(4, 2,new DeflexionPiece("O",PLAYER2,DeflexionPiece.PYRAMID,"NW"));
			BOARD.addPiece(2, 3,new DeflexionPiece("O",PLAYER2,DeflexionPiece.PYRAMID,"NW"));
			BOARD.addPiece(3, 9,new DeflexionPiece("O",PLAYER2,DeflexionPiece.PYRAMID,"NW"));
			BOARD.addPiece(4, 9,new DeflexionPiece("O",PLAYER2,DeflexionPiece.PYRAMID,"SW"));
			BOARD.addPiece(6, 7,new DeflexionPiece("O",PLAYER2,DeflexionPiece.PYRAMID,"NE"));
			BOARD.addPiece(7, 2,new DeflexionPiece("O",PLAYER2,DeflexionPiece.PYRAMID,"NW"));

			BOARD.addPiece(4, 4,new DeflexionPiece("O",PLAYER2,DeflexionPiece.DJED,"NW"));
			BOARD.addPiece(4, 5,new DeflexionPiece("O",PLAYER2,DeflexionPiece.DJED,"NE"));
			
			BOARD.addPiece(7, 3,new DeflexionPiece("O",PLAYER2,DeflexionPiece.OBELISK));
			BOARD.addPiece(7, 5,new DeflexionPiece("O",PLAYER2,DeflexionPiece.OBELISK));
			
			BOARD.addPiece(7, 4,new DeflexionPiece("O",PLAYER2,DeflexionPiece.PHAROAH));
			

			
		}
	}
	
	public boolean gameEnded(){
		if (GAME_ENDED){
			return true;
		}
		if (player1Won()){
			WINNER = PLAYER1;
			GAME_ENDED = true;
			return true;
		}else if (player2Won()){
			WINNER = PLAYER2;
			GAME_ENDED = true;
			return true;
		}
		return false;
	}
	
	public boolean player2Won(){
		if (WINNER  != -1 && WINNER == PLAYER1){
			return true;
		}
		return false;
	}
	
	public boolean player1Won(){
		if (WINNER  != -1 && WINNER == PLAYER2){
			return true;
		}
		return false;
	}	
	
	 
	public boolean won(int Player){
		int cont_X = BOARD.contPieces(PLAYER1);
		int cont_O = BOARD.contPieces(PLAYER2);
		if (PLAYER1 == Player && cont_O == 0 && cont_X > 0){
			return true;
		}else if (PLAYER2 == Player && cont_X == 0 && cont_O > 0){
			return true;
		}
		return false;
	}

	/*
	if ((laser_orientation.equalsIgnoreCase("N")) || (laser_orientation.equalsIgnoreCase("S"))){
		if (ori.contains("E")){
			auxDisparLaser(x,y+1,"E");
		}else if (ori.contains("W")){
			auxDisparLaser(x,y-1,"W");
		}else{
			System.out.println("ERROR invalid deflexion: " + laser_orientation + " - " + ori +"- aux_dispar_laser");
		}
	}else if ((laser_orientation.equalsIgnoreCase("E")) || (laser_orientation.equalsIgnoreCase("W"))){
		if (ori.contains("N")){
			auxDisparLaser(x-1,y,"N");
		}else if (ori.contains("S")){
			auxDisparLaser(x+1,y,"S");
		}else{
			System.out.println("ERROR invalid deflexion2: " + laser_orientation + " - " + ori +"- aux_dispar_laser");
		}							
	}else{
		System.out.println("ERROR invalid deflexion3: " + laser_orientation + " - " + ori +"- aux_dispar_laser");
	}
*/
	
}