package manager;


/**
 * This class extends the generic board game class {@link Game} to support a tic tac toe game.
 * 
 * @author Luciano Antonio Digiampietri
 * @version 0.5 beta - 03/15/2006
 * 
 * @see   Game
 */
public class Tictactoe3DGame extends Game {
	int PLAYER1 = -1;
	int PLAYER2 = -1;	

	public Tictactoe3DGame(String name) {
		super(name);
		GAME_TYPE = "tic tac toe 3D";
		MAX_PLAYERS = 2;
		MIN_PLAYERS = 2;
	}
	
	public Tictactoe3DGame(String name, int player1) {
		super(name, player1);
		GAME_TYPE = "tic tac toe 3D";
		MAX_PLAYERS = 2;
		MIN_PLAYERS = 2;
	}

	public void startGame(){
		if (PLAYERS.size() == 2){
			PLAYER1 = ((Integer)PLAYERS.get(0)).intValue();
			PLAYER2 = ((Integer)PLAYERS.get(1)).intValue();
			ACTUAL_PLAYER = PLAYER1;
			WAITING_PLAYERS=false;
			GAME_ENDED = false;
		}else{
			System.err.println("Wrong number of players:" + PLAYERS.size());
		}
	}
	
	public boolean canAdd(int x, int y, Piece P){
		if ((GAME_ENDED) || (WAITING_PLAYERS)){
			return false;
		}
		if (BOARD.getPiece(x,y).getClass() != NullPiece.class){
			return false;
		}
		int cont_O = BOARD.contPieces(PLAYER2);
		int cont_X = BOARD.contPieces(PLAYER1);

		if (P.getPlayer() == PLAYER2){
			if (cont_O == cont_X-1){
				ACTUAL_PLAYER = PLAYER1;
				return true;
			}
		}else if ((P.getPlayer() == PLAYER1)){
			if (cont_O == cont_X){
				ACTUAL_PLAYER = PLAYER2;
				return true;
			}			
		}
		return false;
	}
	
	public boolean add(int x, int y, int Player){
		TictactoePiece P = null;
		if (Player == PLAYER1){
			P = new TictactoePiece("X",PLAYER1);
		} else if (Player == PLAYER2){
			P = new TictactoePiece("O",PLAYER2);
		} else {
			System.out.println("Invalid player: '" + Player + "'. Players: '"+PLAYER1+"' and '"+PLAYER2+"'.");
			return false;
		}
		if (canAdd(x,y,(Piece)P)){
			if (BOARD.addPiece(x,y,(Piece)P)){
			}else{
				System.out.println("BLASFEMIA!!!");
			}
			if (gameEnded()){
				System.out.println("End game. Winner: " + WINNER);
			}
			CONT_ID++;
			return true;
		}
		return false;
	}
	
	public void initializeBoard(){
		BOARD = new Board(4,16);
	}
	
	public boolean gameEnded(){
		if (GAME_ENDED){
			return true;
		}
		if (player1Won()){
			WINNER = PLAYER1;
			GAME_ENDED = true;
			return true;
		}else if (player2Won()){
			WINNER = PLAYER2;
			GAME_ENDED = true;
			return true;
		}
		return false;
	}
	
	public boolean player1Won(){
		if (WINNER != -1 && WINNER == PLAYER1){
			return true;
		}else if (won(PLAYER1)){
			WINNER = PLAYER1;
			return true;
		}
		return false;
	}
	public boolean player2Won(){
		if (WINNER != -1 && WINNER == PLAYER2){
			return true;
		}else if (won(PLAYER2)){
			WINNER = PLAYER2;
			return true;
		}
		return false;
	}	
	
	
	// PC == Class of the winner 
	public boolean won(int Player){		
		int c1, c2, c3, c4;
		for (int cont=0;cont<16;cont++){
			// Ganhou devido a alguma coluna 
			
			c1 = BOARD.getPiece(0,cont).getPlayer();
			c2 = BOARD.getPiece(1,cont).getPlayer();
			c3 = BOARD.getPiece(2,cont).getPlayer();
			c4 = BOARD.getPiece(3,cont).getPlayer();
			if (c1 == Player && c2 == Player && c3 == Player && c4 == Player){
				//System.out.println("Ganhou devido a alguma coluna");
				return true;
			}
		}
		for (int cont=0;cont<4;cont++){
			// Ganhou devido a alguma linha
			for (int cont2=0;cont2<4;cont2++){
				c1 = BOARD.getPiece(cont,0+cont2*4).getPlayer();
				c2 = BOARD.getPiece(cont,1+cont2*4).getPlayer();
				c3 = BOARD.getPiece(cont,2+cont2*4).getPlayer();
				c4 = BOARD.getPiece(cont,3+cont2*4).getPlayer();
				if (c1 == Player && c2 == Player && c3 == Player && c4 == Player){
					//System.out.println("Ganhou devido a alguma linha");
					return true;
				}
			}
		}
		
		
		for (int cont=0;cont<4;cont++){
			// Ganhou devido a alguma coluna entre dimensoes
			for (int cont2=0;cont2<4;cont2++){
				c1 = BOARD.getPiece(cont,cont2).getPlayer();
				c2 = BOARD.getPiece(cont,cont2 +1*4).getPlayer();
				c3 = BOARD.getPiece(cont,cont2+2*4).getPlayer();
				c4 = BOARD.getPiece(cont,cont2+3*4).getPlayer();
				if (c1 == Player && c2 == Player && c3 == Player && c4 == Player){
					//System.out.println("Ganhou devido a alguma linha");
					return true;
				}
			}
		}

		
		// Ganhou devido a alguma diagonal 1 (x constante)
		for (int cont=0;cont<4;cont++){
			c1 = BOARD.getPiece(cont,0).getPlayer();
			c2 = BOARD.getPiece(cont,5).getPlayer();
			c3 = BOARD.getPiece(cont,10).getPlayer();
			c4 = BOARD.getPiece(cont,15).getPlayer();
			if (c1 == Player && c2 == Player && c3 == Player && c4 == Player){
				//System.out.println("Ganhou devido a alguma linha");
				return true;
			}
		}
		for (int cont=0;cont<4;cont++){
			c1 = BOARD.getPiece(cont,3).getPlayer();
			c2 = BOARD.getPiece(cont,6).getPlayer();
			c3 = BOARD.getPiece(cont,9).getPlayer();
			c4 = BOARD.getPiece(cont,12).getPlayer();
			if (c1 == Player && c2 == Player && c3 == Player && c4 == Player){
				//System.out.println("Ganhou devido a alguma linha");
				return true;
			}
		}
		

		// Ganhou devido a alguma diagonal 2 ("y" constante [no fator de 4])
		for (int cont=0;cont<4;cont++){
			c1 = BOARD.getPiece(0,cont).getPlayer();
			c2 = BOARD.getPiece(1,cont+4).getPlayer();
			c3 = BOARD.getPiece(2,cont+8).getPlayer();
			c4 = BOARD.getPiece(3,cont+12).getPlayer();
			if (c1 == Player && c2 == Player && c3 == Player && c4 == Player){
				//System.out.println("Ganhou devido a alguma linha");
				return true;
			}
		}
		for (int cont=0;cont<4;cont++){
			c1 = BOARD.getPiece(3,cont).getPlayer();
			c2 = BOARD.getPiece(2,cont+4).getPlayer();
			c3 = BOARD.getPiece(1,cont+8).getPlayer();
			c4 = BOARD.getPiece(0,cont+12).getPlayer();
			if (c1 == Player && c2 == Player && c3 == Player && c4 == Player){
				//System.out.println("Ganhou devido a alguma linha");
				return true;
			}
		}

		// Ganhou devido a alguma diagonal 3 ( x e y variando )
		//DIAGONAL PRINCIPAL
		c1 = BOARD.getPiece(0,0).getPlayer();
		c2 = BOARD.getPiece(1,5).getPlayer();
		c3 = BOARD.getPiece(2,10).getPlayer();
		c4 = BOARD.getPiece(3,15).getPlayer();
		if (c1 == Player && c2 == Player && c3 == Player && c4 == Player){
			//System.out.println("Ganhou devido a alguma linha");
			return true;
		}
		
		//DIAGONAL INVERSA
		c1 = BOARD.getPiece(3,0).getPlayer();
		c2 = BOARD.getPiece(2,5).getPlayer();
		c3 = BOARD.getPiece(1,10).getPlayer();
		c4 = BOARD.getPiece(0,15).getPlayer();
		if (c1 == Player && c2 == Player && c3 == Player && c4 == Player){
			//System.out.println("Ganhou devido a alguma linha");
			return true;
		}
		
		
		return false;
	}
}

	