package manager;


/**
 * This class extends the generic board game class {@link Game} to support a tic tac toe game.
 * 
 * @author Luciano Antonio Digiampietri
 * @version 0.5 beta - 03/15/2006
 * 
 * @see   Game
 */
public class TictactoeGame extends Game {
	int PLAYER1 = -1;
	int PLAYER2 = -1;	

	public TictactoeGame(String name) {
		super(name);
		GAME_TYPE = "tictactoe";
		MAX_PLAYERS = 2;
		MIN_PLAYERS = 2;
		GAME_ENDED = false;
	}
	
	public TictactoeGame(String name, int player1) {
		super(name, player1);
		GAME_TYPE = "tictactoe";
		MAX_PLAYERS = 2;
		MIN_PLAYERS = 2;
		GAME_ENDED = false;
	}

	public void startGame(){
		System.out.println("Starting tic tac toe game: # of Players:" + PLAYERS.size());
		if (PLAYERS.size() >= 2){
			PLAYER1 = ((Integer)PLAYERS.get(0)).intValue();
			PLAYER2 = ((Integer)PLAYERS.get(1)).intValue();
			System.out.println("Tic tac toe, players: " + PLAYER1 + " ; " + PLAYER2);
			ACTUAL_PLAYER = PLAYER1;
			WAITING_PLAYERS=false;
			GAME_ENDED = false;
		}else{
			System.err.println("Wrong number of players:" + PLAYERS.size());
		}
	}
	
	public boolean canAdd(int x, int y, Piece P){
		if ((GAME_ENDED) || (WAITING_PLAYERS)){
			return false;
		}
		if (BOARD.getPiece(x,y).getClass() != NullPiece.class){
			return false;
		}
		int cont_O = BOARD.contPieces(PLAYER2);
		int cont_X = BOARD.contPieces(PLAYER1);
		//System.out.println(cont_O + " x " + cont_X);
		if (P.getPlayer() == PLAYER2){
			if (cont_O == cont_X-1){
				ACTUAL_PLAYER = PLAYER1;
				return true;
			}
		}else if ((P.getPlayer() == PLAYER1)){
			if (cont_O == cont_X){
				ACTUAL_PLAYER = PLAYER2;
				return true;
			}			
		}
		return false;
	}
	
	public boolean add(int x, int y, int Player){
		TictactoePiece P = null;
		//System.out.println("Adding: " +x+" "+y+" "+ Player);
		if (Player == PLAYER1){
			P = new TictactoePiece("+",PLAYER1);
		} else if (Player == PLAYER2){
			P = new TictactoePiece("-",PLAYER2);
		} else {
			System.out.println("Invalid player: '" + Player + "'. Players: '"+PLAYER1+"' and '"+PLAYER2+"'.");
			return false;
		}
		if (canAdd(x,y,(Piece)P)){
			if (BOARD.addPiece(x,y,(Piece)P)){
			}else{
				System.out.println("BLASFEMIA!!!");
			}
			//System.err.println(BOARD.contPieces(TictactoePiece.class));
			if ((BOARD.contPieces(TictactoePiece.class) == 9) && WINNER == -1){
				DRAWN_GAME = true;
				GAME_ENDED = true;
				LAST_MESSAGE = "DRAWN GAME";		
			}
			if (gameEnded()){
				if (DRAWN_GAME){
					System.out.println("End game. "+LAST_MESSAGE);
				}else{
					System.out.println("End game. Winner: " + WINNER);
				}
			}
			CONT_ID++;
			return true;
		}
		return false;
	}
	
	public void initializeBoard(){
		BOARD = new Board(3,3);
	}
	
	public boolean gameEnded(){
		if (GAME_ENDED){
			return true;
		}
		if (player1Won()){
			WINNER = PLAYER1;
			GAME_ENDED = true;
			return true;
		}else if (player2Won()){
			WINNER = PLAYER2;
			GAME_ENDED = true;
			return true;
		}
		return false;
	}
	
	public boolean player1Won(){
		if (WINNER != -1 && WINNER == PLAYER1){
			return true;
		}else if (won(PLAYER1)){
			WINNER = PLAYER1;
			return true;
		}
		return false;
	}
	public boolean player2Won(){
		if (WINNER  != -1 && WINNER == PLAYER2){
			return true;
		}else if (won(PLAYER2)){
			WINNER = PLAYER2;
			return true;
		}
		return false;
	}	
	
	
	// PC == Class of the winner 
	public boolean won(int Player){		
		int c1, c2, c3;
		if (Player == -1){
			return false;
		}
		for (int cont=0;cont<3;cont++){
			// Ganhou devido a alguma coluna 
			c1 = BOARD.getPiece(0,cont).getPlayer();
			c2 = BOARD.getPiece(1,cont).getPlayer();
			c3 = BOARD.getPiece(2,cont).getPlayer();
			if (c1 == Player && c2 == Player && c3 == Player){
				return true;
			}
			
			// Ganhou devido a alguma linha
			c1 = BOARD.getPiece(cont,0).getPlayer();
			c2 = BOARD.getPiece(cont,1).getPlayer();
			c3 = BOARD.getPiece(cont,2).getPlayer();
			if (c1 == Player && c2 == Player && c3 == Player){
				return true;
			}
		}
		//	 Ganhou devido a diagonal principal
		c1 = BOARD.getPiece(0,0).getPlayer();
		c2 = BOARD.getPiece(1,1).getPlayer();
		c3 = BOARD.getPiece(2,2).getPlayer();
		if (c1 == Player && c2 == Player && c3 == Player){
			return true;
		}
		
		//	 Ganhou devido a diagonal inversa
		c1 = BOARD.getPiece(0,2).getPlayer();
		c2 = BOARD.getPiece(1,1).getPlayer();
		c3 = BOARD.getPiece(2,0).getPlayer();
		if (c1 == Player && c2 == Player && c3 == Player){
			return true;
		}
		return false;
	}
}

	