package netGameManager;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.UnknownHostException;

/*
 *
 * java NetGameManager/MyTest 127.0.0.1 7 "<new game><checkers><game1><j1><j2>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<new game><checkers><game2><j1><j2>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<join game><0>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<add piece><game_id><x><y>"
 * 
 * cd c:\Usuarios\luciano\eclipse\Projetos\GameManager
 * 
 * java NetGameManager/GameServer 7
 * 
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>new game</RT><GT>checkers</GT></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>new game</RT><GT>tictactoe</GT></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>new game</RT><GT>tictactoe</GT><PLAYER>0</PLAYER></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>join game</RT><GID></GID><PLAYER>1</PLAYER></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>SERVER STATUS</RT></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>GAME STATUS</RT><GID>0</GID></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>join game</RT><GID>1</GID><PLAYER>2</PLAYER></REQUEST>"
 * 
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>new game</RT><GT>tictactoe</GT><PLAYER>0</PLAYER></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>new game</RT><GT>tictactoe</GT><PLAYER>0</PLAYER></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>join game</RT><GID>1</GID><PLAYER>2</PLAYER></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>join game</RT><GID>1</GID><PLAYER>2</PLAYER></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>join game</RT><GID>1</GID><PLAYER>3</PLAYER></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>server status</RT>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>server status</RT></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>new game</RT><GT>tictactoe</GT><PLAYER>0</PLAYER></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>new game</RT><GT>tictactoe</GT><PLAYER>0</PLAYER></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>new game</RT><GT>tictactoe</GT><PLAYER>0</PLAYER></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>delete game</RT><GID>1</GID></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>delete game</RT><GID>1</GID></REQUEST>"
 * 
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>new game</RT><GT>tictactoe</GT><PLAYER>0</PLAYER></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>join game</RT><GID>0</GID><PLAYER>3</PLAYER></REQUEST>"
 * java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>add piece</RT><GID>0</GID><PLAYER>0</PLAYER><X>1</X><Y>1</Y></REQUEST>"
 *
 java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>new game</RT><GT>deflexion</GT><PLAYER>0</PLAYER></REQUEST>"
 java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>join game</RT><GID>0</GID><PLAYER>1</PLAYER></REQUEST>"
 java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>rotate piece</RT><GID>0</GID><PLAYER>0</PLAYER><X>4</X><Y>0</Y><SENSE>CLOCKWISE</SENSE></REQUEST>"
 
 java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>new game</RT><GT>checkers</GT><PLAYER>0</PLAYER></REQUEST>"
 java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>join game</RT><GID>0</GID><PLAYER>1</PLAYER></REQUEST>"
 java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>move piece</RT><GID>0</GID><PLAYER>0</PLAYER><X>2</X><Y>0</Y><X2>3</X2><Y2>1</Y2></REQUEST>"
 java NetGameManager/MyTest 127.0.0.1 7 "<REQUEST><RT>game board</RT><GID>0</GID></REQUEST>"
 * 
 * 
 */

public class MyTest 
{
    public static void main(String args[]) {
    String host = "127.0.0.1";
    int port = 7;
    String message = "TESTE2";
    if (args.length < 1) {
		
		//System.err.println("Usage: java DatagramTest host [port] <file");
	    //System.exit(0);
	}else{
		host = args[0];
	}
    System.out.println("Using port: " + port + " and host: " + host);
	
	if (args.length > 1) {
	    try {
		port = Integer.parseInt(args[1]);
	    } catch (NumberFormatException nfe) { }
	    
	    if (args.length > 2) {
	    	message = args[2];
	    }
	}
	
	//BufferedReader br;
	//br = new BufferedReader(new InputStreamReader(System.in));

	InetAddress addr = null;
	try {
	    addr = InetAddress.getByName(host);
	}
	catch (UnknownHostException uhe) {
	    System.err.println("No such host: " + host);
	    System.exit(0);
	}

	/*
	 * The approach used here, send then immediately
	 * receive, will usually work, but is not totally
	 * reliable.  In a very fast network, or with loopback,
	 * it is possible for the response to arrive before
	 * Java manages to crawl from send to receive.
	 */
	DatagramSocket ds = null;
	DatagramPacket rec, send;
	String line;
	/*Vector MESSAGE = new Vector();
	MESSAGE.add("LINHA 1 DA MENSAGEM ASDFASDFASDFSADFASDFASDF");
	MESSAGE.add("LINHA 2 DA MENSAGEM ASDFASDFASDFSADFASDFASDF");
	MESSAGE.add("LINHA 3 DA MENSAGEM ASDFASDFASDFSADFASDFASDF");
	*/
	rec = new DatagramPacket(new byte[65530], 65530);
	try {
	    ds = new DatagramSocket();
	    //while((line = br.readLine()) != null) {
	    //while((line = br.readLine()) != null) {
//	    for (int cont=0;cont<MESSAGE.size();cont++){
//	    byte [] buf = ((String)MESSAGE.elementAt(cont)).getBytes();
	    byte [] buf = message.getBytes();
		if (buf.length > 0) {
		    send = new DatagramPacket(buf, buf.length, addr, port);
		    rec.setLength(65530);
		    ds.send(send);
		    ds.receive(rec);
		    line = new String(rec.getData(), 0, rec.getLength());
		    System.out.println(line);
		}
	    //}
	}
	catch (IOException ie) {
	    System.err.println("IO exception in datagram test: " + ie);
	}
	finally {
	    if (ds != null) try {
		ds.close();
	    } catch (Exception e) { }
	}
    }
}
